type DecoratorFunc = (target: any, key: string, descriptor: PropertyDescriptor) => void;

const createDecorator = (decorator: DecoratorFunc) => (Model: any, key: string) => {
    const target = Model.prototype;
    const descriptor = Object.getOwnPropertyDescriptor(target, key);
    console.log(descriptor);
    decorator(target, key, descriptor);
};
const logger: DecoratorFunc = (target, key, descriptor) => {
    Object.defineProperty(target, key, {
        ...descriptor,
        value: async (...args: any[]) => {
            try {
                console.log(descriptor, this, args);
                return descriptor.value.apply(this, args);
            } finally {
                const now = new Date().getTime();
                console.log(`lasted logged in ${now.toString()}`);
            }
        },
    });
};
class User {
    async login() {
        console.log('login start');
        await new Promise((resolve) => {
            setTimeout(resolve, 10000);
            console.log('login ................');
        });
    }
}

export const exp1 = () => {
    console.log('exp1');
    const loggerDecorator = createDecorator(logger);
    loggerDecorator(User, 'login');
    const user = new User();
    user.login();
    console.log('user logged', user);
};
