const loggerDecorator = () => {
    return function logMethod(target: any, propertyName: string, propertyDescriptor: PropertyDescriptor) {
        const method = propertyDescriptor.value;

        propertyDescriptor.value = async function (...args: any[]) {
            try {
                return method.call(target, ...args);
            } finally {
                const now = Date.now();
                console.log(`lasted logged in ${now.toString()}`);
            }
        }
        return propertyDescriptor
    }
}
class UserService {
    @loggerDecorator()
    async login() {
        console.log('login success');
        await new Promise((resolve) => {
            setTimeout(resolve, 100);
        });
    }
}

export const exp6 = () => {

    const user = new UserService();
    user.login();
};