export const HiddenDecorator = () => {
    return (target: any, propertyKey: string, descriptor: PropertyDescriptor) => {
        console.log(descriptor);
        descriptor.enumerable = false;
    }
}

export class UserEntity {
    private _nickname: string;
    // @ts-ignore
    private fullName: string;

    @HiddenDecorator()
    @PrefixDecorator('jesse')
    get nickname(): string {
        return this._nickname;
    }

    set nickname(value: string) {
        this._nickname = value;
        this.fullName = `${value}-fullname`;
    }
}

export const exp8 = () => {
    const user = new UserEntity();
    user.nickname = 'leon';
    console.log(user.nickname);
    console.log(Object.keys(user));
}

function PrefixDecorator(prefix: string): (target: any, propertyKey: string, descriptor: PropertyDescriptor) => PropertyDescriptor {
    return (target: any, propertyKey: string, descriptor: PropertyDescriptor) => {
        return {
            ...descriptor,
            set(v) {
                descriptor.set.apply(this, [`${prefix}_${v}`])
            },
        };
    }
}
