import { PostController } from './controllers/post.controller';
import { PostEntity } from './entities/post.entity';
import { TypeOrmModule } from '@nestjs/typeorm';
import { DatabaseModule } from './../database/database.module';
import { PostService } from './services/post.service';
import { PostRepository } from './repositories/post.repository';
import { SanitizeService } from './services/sanitize.service';
import { Module } from "@nestjs/common";

@Module({
    imports: [TypeOrmModule.forFeature([PostEntity]), DatabaseModule.forRepository([PostRepository])],
    controllers: [PostController],
    providers: [SanitizeService, PostRepository, PostService],
    exports: [PostService, DatabaseModule.forRepository([PostRepository])]
})
export class ContentModule { }
