import { ObjectLiteral, SelectQueryBuilder } from "typeorm";

export type QueryHook<Entity> = (
    qb: SelectQueryBuilder<Entity>
) => Promise<SelectQueryBuilder<Entity>>;

export interface PaginateMeta {
    /**
     * 当前页项目数量
     */
    itemCount: number;
    /**
     * 项目总数量
     */
    totalItems?: number;
    /**
     * 每页显示数量
     */
    perPage: number;
    /**
     * 总页数
     */
    totalPages?: number;
    /**
     * 当前页数
     */
    currentPage: number;

}

export interface PaginateOptions {
    /**
     * 当前页数
     */
    page?: number;
    /**
     * 每页显示数量
     */
    limit?: number;
}


export interface PaginateResult<T extends ObjectLiteral> {
    data: T[];
    meta: PaginateMeta;
}
